<?php
/**
 * InlineObject23
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject23 Class Doc Comment
 *
 * @category Class
 * @description filter settings for retrieving callbacks
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject23 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_23';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'timeframe' => 'object',
        'state' => 'string',
        'states' => 'object[]',
        'fromEmployeeId' => 'int',
        'toEmployeeId' => 'int',
        'toAllEmployeesWithAccessTo' => 'bool',
        'toDepartmentIds' => 'int',
        'companyIds' => 'int',
        'employeeIds' => 'int',
        'loadLinkedEntites' => 'bool',
        'withLog' => 'bool',
        'itemsPerPage' => 'int',
        'page' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'timeframe' => null,
        'state' => null,
        'states' => null,
        'fromEmployeeId' => null,
        'toEmployeeId' => null,
        'toAllEmployeesWithAccessTo' => null,
        'toDepartmentIds' => null,
        'companyIds' => null,
        'employeeIds' => null,
        'loadLinkedEntites' => null,
        'withLog' => null,
        'itemsPerPage' => null,
        'page' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timeframe' => 'timeframe',
        'state' => 'state',
        'states' => 'states',
        'fromEmployeeId' => 'fromEmployeeId',
        'toEmployeeId' => 'toEmployeeId',
        'toAllEmployeesWithAccessTo' => 'toAllEmployeesWithAccessTo',
        'toDepartmentIds' => 'toDepartmentIds',
        'companyIds' => 'companyIds',
        'employeeIds' => 'employeeIds',
        'loadLinkedEntites' => 'loadLinkedEntites',
        'withLog' => 'withLog',
        'itemsPerPage' => 'itemsPerPage',
        'page' => 'page'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timeframe' => 'setTimeframe',
        'state' => 'setState',
        'states' => 'setStates',
        'fromEmployeeId' => 'setFromEmployeeId',
        'toEmployeeId' => 'setToEmployeeId',
        'toAllEmployeesWithAccessTo' => 'setToAllEmployeesWithAccessTo',
        'toDepartmentIds' => 'setToDepartmentIds',
        'companyIds' => 'setCompanyIds',
        'employeeIds' => 'setEmployeeIds',
        'loadLinkedEntites' => 'setLoadLinkedEntites',
        'withLog' => 'setWithLog',
        'itemsPerPage' => 'setItemsPerPage',
        'page' => 'setPage'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timeframe' => 'getTimeframe',
        'state' => 'getState',
        'states' => 'getStates',
        'fromEmployeeId' => 'getFromEmployeeId',
        'toEmployeeId' => 'getToEmployeeId',
        'toAllEmployeesWithAccessTo' => 'getToAllEmployeesWithAccessTo',
        'toDepartmentIds' => 'getToDepartmentIds',
        'companyIds' => 'getCompanyIds',
        'employeeIds' => 'getEmployeeIds',
        'loadLinkedEntites' => 'getLoadLinkedEntites',
        'withLog' => 'getWithLog',
        'itemsPerPage' => 'getItemsPerPage',
        'page' => 'getPage'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const STATE_UNSEEN = 'UNSEEN';
    public const STATE__NEW = 'NEW';
    public const STATE_NOBODY_ANSWERED = 'NOBODY_ANSWERED';
    public const STATE_BUSY = 'BUSY';
    public const STATE_NOT_PRESENT = 'NOT_PRESENT';
    public const STATE_NEW_CALLBACK_REENTERED = 'NEW_CALLBACK_REENTERED';
    public const STATE_COMPLETED = 'COMPLETED';
    public const STATE_EXPECTED_CALLBACK = 'EXPECTED_CALLBACK';
    public const STATE_EXPECTED_CALLBACK_COMPLETED = 'EXPECTED_CALLBACK_COMPLETED';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStateAllowableValues()
    {
        return [
            self::STATE_UNSEEN,
            self::STATE__NEW,
            self::STATE_NOBODY_ANSWERED,
            self::STATE_BUSY,
            self::STATE_NOT_PRESENT,
            self::STATE_NEW_CALLBACK_REENTERED,
            self::STATE_COMPLETED,
            self::STATE_EXPECTED_CALLBACK,
            self::STATE_EXPECTED_CALLBACK_COMPLETED,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timeframe'] = $data['timeframe'] ?? null;
        $this->container['state'] = $data['state'] ?? null;
        $this->container['states'] = $data['states'] ?? null;
        $this->container['fromEmployeeId'] = $data['fromEmployeeId'] ?? null;
        $this->container['toEmployeeId'] = $data['toEmployeeId'] ?? null;
        $this->container['toAllEmployeesWithAccessTo'] = $data['toAllEmployeesWithAccessTo'] ?? null;
        $this->container['toDepartmentIds'] = $data['toDepartmentIds'] ?? null;
        $this->container['companyIds'] = $data['companyIds'] ?? null;
        $this->container['employeeIds'] = $data['employeeIds'] ?? null;
        $this->container['loadLinkedEntites'] = $data['loadLinkedEntites'] ?? null;
        $this->container['withLog'] = $data['withLog'] ?? null;
        $this->container['itemsPerPage'] = $data['itemsPerPage'] ?? null;
        $this->container['page'] = $data['page'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getStateAllowableValues();
        if (!is_null($this->container['state']) && !in_array($this->container['state'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'state', must be one of '%s'",
                $this->container['state'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timeframe
     *
     * @return object|null
     */
    public function getTimeframe()
    {
        return $this->container['timeframe'];
    }

    /**
     * Sets timeframe
     *
     * @param object|null $timeframe timeframe
     *
     * @return self
     */
    public function setTimeframe($timeframe)
    {
        $this->container['timeframe'] = $timeframe;

        return $this;
    }

    /**
     * Gets state
     *
     * @return string|null
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     *
     * @param string|null $state Describes a current \"state\" of a callback
     *
     * @return self
     */
    public function setState($state)
    {
        $allowedValues = $this->getStateAllowableValues();
        if (!is_null($state) && !in_array($state, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'state', must be one of '%s'",
                    $state,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets states
     *
     * @return object[]|null
     */
    public function getStates()
    {
        return $this->container['states'];
    }

    /**
     * Sets states
     *
     * @param object[]|null $states if multiple states have to be filtered, give an array here
     *
     * @return self
     */
    public function setStates($states)
    {
        $this->container['states'] = $states;

        return $this;
    }

    /**
     * Gets fromEmployeeId
     *
     * @return int|null
     */
    public function getFromEmployeeId()
    {
        return $this->container['fromEmployeeId'];
    }

    /**
     * Sets fromEmployeeId
     *
     * @param int|null $fromEmployeeId filters only callbacks which were created by this employee (technician)
     *
     * @return self
     */
    public function setFromEmployeeId($fromEmployeeId)
    {
        $this->container['fromEmployeeId'] = $fromEmployeeId;

        return $this;
    }

    /**
     * Gets toEmployeeId
     *
     * @return int|null
     */
    public function getToEmployeeId()
    {
        return $this->container['toEmployeeId'];
    }

    /**
     * Sets toEmployeeId
     *
     * @param int|null $toEmployeeId filters only callbacks to this employee (techncian)
     *
     * @return self
     */
    public function setToEmployeeId($toEmployeeId)
    {
        $this->container['toEmployeeId'] = $toEmployeeId;

        return $this;
    }

    /**
     * Gets toAllEmployeesWithAccessTo
     *
     * @return bool|null
     */
    public function getToAllEmployeesWithAccessTo()
    {
        return $this->container['toAllEmployeesWithAccessTo'];
    }

    /**
     * Sets toAllEmployeesWithAccessTo
     *
     * @param bool|null $toAllEmployeesWithAccessTo if \"toEmployeeId\" is given, also retrieves all callbacks which the user has access to
     *
     * @return self
     */
    public function setToAllEmployeesWithAccessTo($toAllEmployeesWithAccessTo)
    {
        $this->container['toAllEmployeesWithAccessTo'] = $toAllEmployeesWithAccessTo;

        return $this;
    }

    /**
     * Gets toDepartmentIds
     *
     * @return int|null
     */
    public function getToDepartmentIds()
    {
        return $this->container['toDepartmentIds'];
    }

    /**
     * Sets toDepartmentIds
     *
     * @param int|null $toDepartmentIds filters only callbacks for these departments
     *
     * @return self
     */
    public function setToDepartmentIds($toDepartmentIds)
    {
        $this->container['toDepartmentIds'] = $toDepartmentIds;

        return $this;
    }

    /**
     * Gets companyIds
     *
     * @return int|null
     */
    public function getCompanyIds()
    {
        return $this->container['companyIds'];
    }

    /**
     * Sets companyIds
     *
     * @param int|null $companyIds filters only callbacks for these (customer) companies (ids given here)
     *
     * @return self
     */
    public function setCompanyIds($companyIds)
    {
        $this->container['companyIds'] = $companyIds;

        return $this;
    }

    /**
     * Gets employeeIds
     *
     * @return int|null
     */
    public function getEmployeeIds()
    {
        return $this->container['employeeIds'];
    }

    /**
     * Sets employeeIds
     *
     * @param int|null $employeeIds filters only callbacks for these (customer) employees (ids given here)
     *
     * @return self
     */
    public function setEmployeeIds($employeeIds)
    {
        $this->container['employeeIds'] = $employeeIds;

        return $this;
    }

    /**
     * Gets loadLinkedEntites
     *
     * @return bool|null
     */
    public function getLoadLinkedEntites()
    {
        return $this->container['loadLinkedEntites'];
    }

    /**
     * Sets loadLinkedEntites
     *
     * @param bool|null $loadLinkedEntites if true, \"linked entities\" will be loaded as well (given in the responses \"meta\" section)
     *
     * @return self
     */
    public function setLoadLinkedEntites($loadLinkedEntites)
    {
        $this->container['loadLinkedEntites'] = $loadLinkedEntites;

        return $this;
    }

    /**
     * Gets withLog
     *
     * @return bool|null
     */
    public function getWithLog()
    {
        return $this->container['withLog'];
    }

    /**
     * Sets withLog
     *
     * @param bool|null $withLog if true, will also load all state logs of the retrieved callbacks
     *
     * @return self
     */
    public function setWithLog($withLog)
    {
        $this->container['withLog'] = $withLog;

        return $this;
    }

    /**
     * Gets itemsPerPage
     *
     * @return int|null
     */
    public function getItemsPerPage()
    {
        return $this->container['itemsPerPage'];
    }

    /**
     * Sets itemsPerPage
     *
     * @param int|null $itemsPerPage if pagination shall be used, give here the items per page
     *
     * @return self
     */
    public function setItemsPerPage($itemsPerPage)
    {
        $this->container['itemsPerPage'] = $itemsPerPage;

        return $this;
    }

    /**
     * Gets page
     *
     * @return int|null
     */
    public function getPage()
    {
        return $this->container['page'];
    }

    /**
     * Sets page
     *
     * @param int|null $page if pagination shall be used, the page number is given here
     *
     * @return self
     */
    public function setPage($page)
    {
        $this->container['page'] = $page;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


